# encoding: utf8
#
#  El sistema masa-resorte-amortiguador 
# sujeto a fuenzas que cambian rápidamente:
# 
#  t=0, f = 2
#  t=2, f = 4
#  t=4, f = 1 
#  t=6, f = 5
#
# Fraga 30/10/2017

class SMRA :
	def __init__( self, m, b, k ) :
		self.m = m
		self.b = b
		self.k = k
		self.dt = 1.0/30.0
		self.k1 = 2.0 - self.dt*b/m - self.dt*self.dt*k/m
		self.k2 = self.dt*b/m - 1.0  
		self.k3 = 0.0
		self.x = 0.0
		self.x_1 = 0.0
		self.y = 0.0
		# Se hace la simulación empezando en la posición en cero

	def pone_fuerza( self, f ) :
		self.k3 = self.dt*self.dt*f/self.m

	def pone_posicion( self, y ) :
		self.y = y

	def simula( self, t0, tiempo ) :
		pasos = int(tiempo * 30)
		i = 0
		while i < pasos :
			x1 = self.k1*self.x + self.k2*self.x_1 + self.k3
			t = t0 + i * self.dt
			print t, x1
			self.x_1 = self.x
			self.x = x1
			i += 1

	def pone_control( self, kp, kd ) :
		self.kp = kp
		self.kd = kd
		self.error = 0.0
		self.error_1 = 0.0

	def simula_con_control( self, t0, tiempo ) :
		pasos = int(tiempo * 30)
		i = 0
		while i < pasos :
			self.error = self.y - self.x
			f = self.kp * self.error + self.kd*(self.error - self.error_1)/self.dt
			self.k3 = self.dt*self.dt*f/self.m
			self.error_1 = self.error	

			x1 = self.k1*self.x + self.k2*self.x_1 + self.k3
			t = t0 + i * self.dt
			print t, x1
			self.x_1 = self.x
			self.x = x1
			i += 1

smra = SMRA( 0.1, 0.25, 1 )
smra.pone_control( 13.0, 2.0 )

smra.pone_fuerza( 2 ) 
smra.simula( 0, 2)

smra.pone_posicion( 4 ) 
smra.simula_con_control( 2, 2 )

smra.pone_posicion( 1 ) 
smra.simula_con_control( 4, 2 )

smra.pone_posicion( 5 ) 
smra.simula_con_control( 6, 5 )
